/*==================================================================================
** COMPANY		= Wolverhampton University - Third Year Project
** PROJECT      = Temperature Data Recorder
** MODULE       =
** VERSION      = 0.0
** DATE         = 08-06-2010
** LAST CHANGE  =
** =================================================================================
** Description: Initial setup of RS232 Communications
**
** Enviroment:  Device: PIC 16F684   	 	    Version:
**              Assembler: HI-TECH PICC Lite    Version: Version 9.60
**              C-Compiler: HI-TECH PICC Lite   Version: Version 9.60
**              Linker: HI-TECH PICC Lite       Version: Version 9.60
**				Programmer: PICkit(tm)1  	    Version:	Flash Starter Kit, V1.60.0
** =================================================================================														Firmware Version 2.0.2.** =================================================================================
** By:          James Mason
** =================================================================================
**  Driving the RS232 on the PC Directly and not with a MAX232 inverter chip
**
**  Settings:
**			 Baud Rate:	4800
**			 Data Bits:	8
**			 Parity:	None
**			 Stop Bits:	1
**			 Flow Control: None
** =================================================================================
Changes:
** =================================================================================
*/

#include	<htc.h>
#include 	<STDIO.h>
#include "Serial.h"

#define SERIAL_PORT	PORTA
#define SERIAL_TRIS	TRISA
#define RX_PIN		0
#define	TX_PIN		1
#define TxData	RA1
#define RxData	RA0
// #define DELAY 57  	// 57 works with the 16F684
// #define DELAY 100	// Gives 160uS per Bit with the 16F636
// #define DELAY 150	// Gives 232uS Per Bit with the 16F636
// #define DELAY 125	// Gives 180uS Per Bit with the 16F636
// #define DELAY 135	// Gives 200uS Per Bit with the 16F636
#define DELAY 136		// Gives 210uS Per Bit with the 16F636
// #define DELAY 137	// Gives 220uS Per Bit with the 16F636
#define IDELAY 3

unsigned char bitno;
unsigned char dly;

void newline(void)
  {
       putch (0x0D);	// Carriage Return
       putch (0x0A);	// Line Feed
       putch ('>');
  }

unsigned char conversion (unsigned char data)
{
  data = data - '0';
   if (data > 9)
      data -= 7;
   return (data);
}

void send_2D (unsigned char num)
{
   unsigned char C;

      C = num / 16;
      if (C>9)
      	C+=7;
      C+=0x30;
      putch (C);

      num &=0x0f;
      if (num>9)
      	num+=7;
      num+=0x30;
      putch (num);
}

void send_4D (unsigned int num)
{
  send_2D(num/256);
  send_2D(num);
}

void putch (char c)
{
	CLRWDT ();		// Clear Watchdog
	TxData = 1;			/* start bit */
	bitno = 12;

	do {
			dly = DELAY;	/* wait one bit time */
			do
				/* waiting in delay loop */ ;
			while(--dly);
			if(c & 1)
				TxData = 0;
			if (!(c & 1))
				TxData = 1;
			c = (c >> 1) | 0x80;

		} while(--bitno);

	NOP();
}


char getch (void)
{
	unsigned char	c, bitno;

	for(;;) {

		while(!RxData)
		{
			CLRWDT ();
			// continue;	/* wait for start bit */
		}

		dly = DELAY/2;
		do
			/* waiting in delay loop */ ;
		while(--dly);
		if(!RxData)
			continue;	/* twas just noise */
		bitno = 8;
		c = 0;
		do {
			dly = DELAY;
			do
			/* waiting in delay loop */ ;
			while(--dly);

			c/=2;
			if (!RxData)
				c|=0x80;

		} while(--bitno);
		return c;
	}
}





